--                                                    Rolf Schrder 2001-09-18
--> WORDS.E   Read|Write 16-bit words from address a  Mrkenweg 37
--     by Bernie Ryan, modified by R.S.        21029 Hamburg, Germany
--  Language: EUPHORIA ver. 2.2                       r.schr@t-online.de
------------------------------------------------------------------------------
include machine.e   -- allocate()
------------------------------------------------------------------------------
constant stack  = allocate( 8)  --  space for adress and value
constant pokew_ = allocate(18)  --  space for machine code
constant peekw_ = allocate(18)  --  space for machine code
------------------------------------------------------------------------------
    poke(pokew_, {            -- poke_: @
	#60,                  -- pushad          ; save all the registers
	#BD,#00,#00,#00,#00,  -- mov ebp, stack  ; point base pointer to stack
	#8B,#55,#00,          -- mov edx,[ebp+0] ; get the memory address
	#66,#8B,#45,#04,      -- mov ax,[ebp+4]  ; get the value (16 bit)
	#66,#89,#02,          -- mov [edx],ax    ; store the value in memory
	#61,                  -- popad           ; restore all the registers
	#C3})                 -- ret             ; back to Euphoria
    poke4(pokew_ + 2, stack)
------------------------------------------------------------------------------
    poke(peekw_, {            -- peek_: @
	#60,                  -- pushad          ; save all the registers
	#BD,#00,#00,#00,#00,  -- mov ebp, stack  ; point base pointer to stack
	#8B,#55,#00,          -- mov edx,[ebp+0] ; get the memory address
	#66,#8B,#02,          -- mov ax,[edx]    ; get 16 bit from memory to ax
	#66,#89,#45,#04,      -- mov [ebp+4],ax  ; store value at stack+4
	#61,                  -- popad           ; restore all the registers
	#C3})                 -- ret             ; back to Euphoria
    poke4(peekw_ + 2, stack)
------------------------------------------------------------------------------

global procedure poke2(atom memory, object value)
--               
    if atom(value) then
	value = and_bits(value,#FFFF)   -- cut down to lower 16 bits 
	poke4(stack  ,memory)           -- set parameters
	poke4(stack+4,value)            -- set parameters
	call(pokew_)                    -- call assembler code
    else
	for i = 0 to length(value)-1 do
	    poke2(memory+2*i,value[i+1])
	end for
    end if
end procedure
------------------------------------------------------------------------------

global function peek2u(object memory)
--              
    sequence s
    integer  v
    
    if atom(memory) then
	poke4(stack, memory)                    -- set parameter
	call(peekw_)                            -- call assembler code
	v = and_bits(peek4u(stack+4),#FFFF)     -- get value
	return v
    else
	s = {}
	for i = 0 to memory[2]-1 do
	    s &= peek2u(memory[1]+2*i)
	end for
	return s
    end if
end function
------------------------------------------------------------------------------

global function peek2s(object memory)
--              
    sequence s
    integer  v
    
    if atom(memory) then
	poke4(stack, memory)                    -- set parameter
	call(peekw_)                            -- call assembler code
	v = and_bits(peek4u(stack+4),#FFFF)     -- get value
	if v > #7FFF then
	    return v - #10000
	else
	    return v
	end if
    else
	s = {}
	for i = 0 to memory[2]-1 do
	    s &= peek2s(memory[1]+2*i)
	end for
	return s
    end if
end function
------------------------------------------------------------------------------
